Index: /trunk/docs/_static/default.css
===================================================================
--- /trunk/docs/_static/default.css	(revision 119)
+++ /trunk/docs/_static/default.css	(revision 120)
@@ -15,7 +15,7 @@
 
 body {
-    font-family: sans-serif;
-    font-size: 100%;
-    background-color: #11303d;
+    font-family: Verdana, Arial, Helvetica, sans-serif;
+    font-size: 14px;
+    background-color: #ffffff;
     color: #000;
     margin: 0;
@@ -24,5 +24,5 @@
 
 div.document {
-    background-color: #1c4e63;
+    background-color: white;
 }
 
@@ -38,5 +38,5 @@
 div.body {
     background-color: #ffffff;
-    color: #000000;
+    color: #333333;
     padding: 0 20px 30px 20px;
 }
@@ -46,5 +46,5 @@
 
 div.footer {
-    color: #ffffff;
+    color: #646464;
     width: 100%;
     padding: 9px 0 9px 0;
@@ -54,10 +54,10 @@
 
 div.footer a {
-    color: #ffffff;
+    color: #646464;
     text-decoration: underline;
 }
 
 div.related {
-    background-color: #133f52;
+    background-color: #5e3905;
     line-height: 30px;
     color: #ffffff;
@@ -73,6 +73,6 @@
 
 div.sphinxsidebar h3 {
-    font-family: 'Trebuchet MS', sans-serif;
-    color: #ffffff;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    color: #663e05;
     font-size: 1.4em;
     font-weight: normal;
@@ -82,10 +82,10 @@
 
 div.sphinxsidebar h3 a {
-    color: #ffffff;
+    color: #333333;
 }
 
 div.sphinxsidebar h4 {
-    font-family: 'Trebuchet MS', sans-serif;
-    color: #ffffff;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    color: #663e05;
     font-size: 1.3em;
     font-weight: normal;
@@ -95,5 +95,5 @@
 
 div.sphinxsidebar p {
-    color: #ffffff;
+    color: #333333;
 }
 
@@ -109,5 +109,5 @@
 
 div.sphinxsidebar a {
-    color: #98dbcc;
+    color: #333333;
 }
 
@@ -123,10 +123,10 @@
 
 a {
-    color: #355f7c;
+    color: #ffac59;
     text-decoration: none;
 }
 
 a:visited {
-    color: #355f7c;
+    color: #ffac59;
     text-decoration: none;
 }
@@ -146,19 +146,18 @@
 div.body h5,
 div.body h6 {
-    font-family: 'Trebuchet MS', sans-serif;
-    background-color: #f2f2f2;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    background-color: #ffffff;
     font-weight: normal;
-    color: #20435c;
-    border-bottom: 1px solid #ccc;
+    color: #663e05;
     margin: 20px -20px 10px -20px;
     padding: 3px 0 3px 10px;
 }
 
-div.body h1 { margin-top: 0; font-size: 200%; }
-div.body h2 { font-size: 160%; }
-div.body h3 { font-size: 140%; }
-div.body h4 { font-size: 120%; }
-div.body h5 { font-size: 110%; }
-div.body h6 { font-size: 100%; }
+div.body h1 { margin-top: 0; font-size: 140%; }
+div.body h2 { font-size: 120%; }
+div.body h3 { font-size: 100%; }
+div.body h4 { font-size: 90%; }
+div.body h5 { font-size: 80%; }
+div.body h6 { font-size: 70%; }
 
 a.headerlink {
Index: /trunk/docs/_templates/index.html
===================================================================
--- /trunk/docs/_templates/index.html	(revision 120)
+++ /trunk/docs/_templates/index.html	(revision 120)
@@ -0,0 +1,3 @@
+{% extends "layout.html" %}
+{% set title = 'Overview' %}
+
Index: /trunk/docs/_templates/indexsidebar.html
===================================================================
--- /trunk/docs/_templates/indexsidebar.html	(revision 120)
+++ /trunk/docs/_templates/indexsidebar.html	(revision 120)
@@ -0,0 +1,23 @@
+<table width="100%" cellspacing="10" style="width: 100%; background-color: #b8b9bb;">
+  <tr>
+    <td>
+      <a href="download.html">
+        <img src="_static/images/download.jpg" border="0px;" />
+      </a>
+    </td>
+  </tr>
+  <tr>
+    <td>
+      <a href="https://www.paypal.com/us/cgi-bin/webscr?cmd=_flow&SESSION=tSBDSUrN-pN-d3zZtpiuiW-QNEbjlnxta6hy1rmeICIKlJAxpPcpvK6npbi&dispatch=5885d80a13c0db1f8e263663d3faee8d5fa8ff279e37c3d9d4e38bdbee0ede69">
+        <img src="_static/images/donate.jpg" border="0px;" />
+      </a>
+    </td>
+  </tr>
+  <tr>
+    <td>
+      <a href="http://twitter.com/ZOO_Project">
+        <img src="_static/images/twitter.jpg" border="0px;" />
+      </a>
+    </td>
+  </tr>
+</table>
Index: /trunk/docs/_templates/layout.html
===================================================================
--- /trunk/docs/_templates/layout.html	(revision 120)
+++ /trunk/docs/_templates/layout.html	(revision 120)
@@ -0,0 +1,15 @@
+{% extends "!layout.html" %}
+
+{% block header %}
+    <img src="_static/images/header-logo.jpg">
+    {{ super() }}
+{% endblock %}
+
+{% block rootrellink %}
+    <li><a href="http://www.zoo-project.org/">Project Homepage</a> &raquo;</li>
+    {{ super() }}
+{% endblock %}
+
+{# put the sidebar before the body #}
+{% block sidebar1 %}{% endblock %}
+{% block sidebar2 %}{{ sidebar() }}{% endblock %}
Index: /trunk/docs/conf.py
===================================================================
--- /trunk/docs/conf.py	(revision 119)
+++ /trunk/docs/conf.py	(revision 120)
@@ -97,14 +97,16 @@
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {
-#     "rightsidebar": "true"
-#    "headbgcolor": "#ffffff",
-#    "bgcolor": "#ffffff",
-#    "textcolor": "#646464",
-#    "linkcolor": "#fc9326",
-#    "visitedlinkcolor": "#fc9326",    
-#    "sidebarbgcolor": "red",
-#    "relbarbgcolor": "#5e3905"    
-#}
+html_theme_options = {
+    "rightsidebar": "true",
+    "headbgcolor": "#ffffff",
+    "bgcolor": "#ffffff",
+    "textcolor": "#333333",
+    "linkcolor": "#fc9326",
+    "visitedlinkcolor": "#fc9326",    
+    "sidebarbgcolor": "white",
+    "footerbgcolor": "#ffffff",
+    "footertextcolor": "#646464",    
+    "relbarbgcolor": "#5e3905"    
+}
 
 # Add any paths that contain custom themes here, relative to this directory.
@@ -113,17 +115,17 @@
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-#html_title = None
+html_title = "ZOO Project " + release + " documentation"
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+html_short_title = "Documentation"
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+#html_logo = 
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+html_favicon = "favicon.ico"
 
 # Add any paths that contain custom static files (such as style sheets) here,
@@ -141,5 +143,7 @@
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+html_sidebars = {
+'**': ['globaltoc.html', 'sourcelink.html', 'searchbox.html'],
+"index":["indexsidebar.html",'searchbox.html']}
 
 # Additional templates that should be rendered to pages, maps page names to
@@ -157,5 +161,5 @@
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+html_show_sourcelink = False
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
Index: /trunk/docs/copyright.txt
===================================================================
--- /trunk/docs/copyright.txt	(revision 120)
+++ /trunk/docs/copyright.txt	(revision 120)
@@ -0,0 +1,22 @@
+.. _license:
+
+ZOO Kernel MIT/X-11 License
+===========================
+
+Copyright (c) 2010-2011 GeoLabs
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
+and associated documentation files (the "Software"), to deal in the Software without restriction, 
+including without limitation the rights to use, copy, modify, merge, publish, distribute, 
+sublicense, and/or sell copies of the Software, and to permit persons to whom the Software 
+is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all copies or 
+substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
+INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
+PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
+FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
+ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
+SOFTWARE. 
Index: /trunk/docs/download.txt
===================================================================
--- /trunk/docs/download.txt	(revision 120)
+++ /trunk/docs/download.txt	(revision 120)
@@ -0,0 +1,30 @@
+.. _download:
+
+ZOO Kernel Download
+===================
+
+ZOO Kernel is open source software available under the terms of the :ref:`MIT/X-11 style license <license>`. 
+Please see details of the ZOO Kernel license at the bottom of this page. Source code can 
+be compliled under Linux, Mac and Windows platforms. The latest ZOO Kernel version is 
+ZOO Kernel 1.0.
+
+Download ZOO Kernel source code
+-------------------------------
+
+`ZOO-Kernel-1.0.tar.bz2 <dl/ZOO-Kernel-1.0.tar.bz2>`__ / `ZOO-Kernel-1.0.zip <dl/ZOO-Kernel-1.0.zip>`__
+
+Or get the source code through SVN :
+
+::
+
+  svn checkout http://svn.zoo-project.org/svn/trunk zoo
+ 
+For registred developers, as the server waiting incoming SSH connexions on the 1046 port, 
+you'll have to edit your ~/.subversion/config file to add a tunnel. Let us name it as 
+zoossh, you can then use the following command :
+
+::
+
+  # sed "s:\[tunnels\]:\[tunnels\]\nzoosvn = /usr/bin/ssh -p 1046:g" -i ~/.subversion/config
+  # svn co svn+zoosvn://svn.zoo-project.org/var/svn/repos/trunk zoo-project
+ 
Index: /trunk/docs/index.txt
===================================================================
--- /trunk/docs/index.txt	(revision 119)
+++ /trunk/docs/index.txt	(revision 120)
@@ -2,5 +2,5 @@
 ==========================
 
-ZOO is a WPS (Web Processing Service) open source project released under a MIT/X-11 style license. 
+ZOO is a WPS (Web Processing Service) open source project released under a :ref:`MIT/X-11 style license <license>`. 
 It provides an OGC WPS compliant developer-friendly framework to create and chain WPS Web services. 
 ZOO is made of three parts: