Index: /trunk/docs/_static/default.css
===================================================================
--- /trunk/docs/_static/default.css	(revision 120)
+++ /trunk/docs/_static/default.css	(revision 121)
@@ -258,2 +258,79 @@
     border-bottom: 1px solid #ac9;
 }
+
+/*  Menu Bar ---------------------------------------- */
+
+ul.topnav {
+	position:relative;
+	top:0;
+	left:0;
+	list-style: none;
+	padding: 0 ;	
+	margin: 0;
+	float: left;
+	width: 100%;
+	height:40px;
+	background: #563404;
+filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#563404', endColorstr='#663e05'); /* for IE */
+background:-webkit-gradient(linear, left top, left bottom, from(#563404), to(#663e05)); /* for webkit browsers */
+background:-moz-linear-gradient(top,  #563404,  #663e05); /* for firefox 3.6+ */
+	font-size: 1.2em;
+}
+ul.topnav li {
+	float: left;
+	margin: 0;	
+	padding: 0 15px 0 0;
+	position: relative; /*--Declare X and Y axis base--*/
+}
+ul.topnav li a{
+	padding: 6px 10px 10px 20px;
+	color: #fff;
+	display: block;
+	text-decoration: none;
+	float: left;
+	
+}
+ul.topnav li a:hover{
+	background: transparent;
+	color:#ffcd0b;
+}
+ul.topnav li span { /*--Drop down trigger styles--*/
+	width: 17px;
+	height: 35px;
+	float: left;
+}
+ul.topnav li span.subhover {background-position: center bottom; cursor: pointer;} /*--Hover effect for trigger--*/
+ul.topnav li ul.subnav {
+	list-style: none;
+	position: absolute; /*--Important - Keeps subnav from affecting main navigation flow--*/
+	left: 20px; top: 35px;
+	margin: 0; padding: 0;
+	display: none;
+	float: left;
+	width: 170px;
+	-moz-border-radius-bottomleft: 5px;
+	-moz-border-radius-bottomright: 5px;
+	-webkit-border-bottom-left-radius: 5px;
+	-webkit-border-bottom-right-radius: 5px;
+	border: 1px solid #663e05;
+	z-index:1000000;
+	
+
+}
+ul.topnav li ul.subnav li{
+	margin: 0; padding: 0;
+
+	clear: both;
+	width: 125px;
+}
+html ul.topnav li ul.subnav li a {
+		font-size:.8em;
+	float: left;
+	width: 155px;
+	background: #663e05;
+	padding:3px 5px 3px 10px ;
+
+}
+html ul.topnav li ul.subnav li a:hover { /*--Hover effect for subnav links--*/
+ 
+}
Index: /trunk/docs/_templates/layout.html
===================================================================
--- /trunk/docs/_templates/layout.html	(revision 120)
+++ /trunk/docs/_templates/layout.html	(revision 121)
@@ -1,11 +1,74 @@
 {% extends "!layout.html" %}
+
+{% block extrahead %}
+
+<script type="text/javascript">
+$(document).ready(function(){
+
+	$("ul.topnav li a").hover(function() {
+
+		//Following events are applied to the subnav itself (moving subnav up and down)
+		$(this).parent().find("ul.subnav").slideDown('fast').show(); //Drop down the subnav on click
+
+		$(this).parent().hover(function() {
+		}, function(){
+			$(this).parent().find("ul.subnav").slideUp('slow'); //When the mouse hovers out of the subnav, move it back up
+		});
+
+		//Following events are applied to the trigger (Hover events for the trigger)
+		}).hover(function() {
+			$(this).addClass("subhover"); //On hover over, add class "subhover"
+		}, function(){	//On Hover Out
+			$(this).removeClass("subhover"); //On hover out, remove class "subhover"
+	});
+
+});
+</script>
+
+    {{ super() }}
+{% endblock %}
 
 {% block header %}
     <img src="_static/images/header-logo.jpg">
-    {{ super() }}
-{% endblock %}
 
-{% block rootrellink %}
-    <li><a href="http://www.zoo-project.org/">Project Homepage</a> &raquo;</li>
+<ul class="topnav">
+  <li><a href="/site/">Home</a></li>
+  <li><a href="#">ZOO Project</a>
+       <ul class="subnav">
+
+         <li><a href="/site/ZooWebSite/ZooProject/About">About</a></li>
+         <li><a href="/site/ZooWebSite/ZooProject/Tribe">ZOO Tribe</a></li>
+         <li><a href="/site/ZooWebSite/ZooProject/Events">Events</a></li>
+         <li><a href="/site/ZooWebSite/ZooProject/Photos">Photos</a></li>
+         <li><a href="/site/ZooWebSite/ZooProject/Contact">Contacts</a></li>
+       </ul>
+
+  </li>
+  <li>
+    <a href="#">Components</a>
+    <ul class="subnav">
+      <li><a href="/site/ZooWebSite/ZooKernel">ZOO Kernel</a></li>
+      <li><a href="/site/ZooWebSite/ZooServices">ZOO Services</a></li>
+      <li><a href="/site/ZooWebsite/ZooApi">ZOO API</a></li>
+
+    </ul>
+  </li>
+  <li><a href="download.html">Download</a></li>
+  <li><a href="/site/ZooDocumentation">Docs</a></li>
+  <li><a href="#">Demos</a>
+    <ul class="subnav">
+      <li><a href="/site/ZooWebSite/Demo/SpatialTools">ZOO Spatial Tools</a></li>
+
+      <li><a href="/site/ZooWebSite/Demo/CGAL">ZOO CGAL Vor</a></li>
+      <li><a href="/site/ZooWebSite/Demo/WFS-T">ZOO Mapserver WFS-T</a></li>
+      <li><a href="/site/ZooWebSite/Demo/GdalProfile">ZOO Elevation Profile</a></li>
+      <li><a href="/site/ZooWebSite/Demo/FormTools">ZOO Form tools</a></li>
+    </ul>
+  </li>
+  <li><a href="/trac">Trac</a></li>
+
+</ul>
+
+
     {{ super() }}
 {% endblock %}
@@ -14,2 +77,5 @@
 {% block sidebar1 %}{% endblock %}
 {% block sidebar2 %}{{ sidebar() }}{% endblock %}
+
+{# remove first relbar #}
+{% block relbar1 %}{% endblock %}
Index: /trunk/docs/conf.py
===================================================================
--- /trunk/docs/conf.py	(revision 120)
+++ /trunk/docs/conf.py	(revision 121)
@@ -38,5 +38,5 @@
 
 # The master toctree document.
-master_doc = 'index'
+master_doc = 'documentation'
 
 # General information about the project.
Index: /trunk/docs/documentation.txt
===================================================================
--- /trunk/docs/documentation.txt	(revision 121)
+++ /trunk/docs/documentation.txt	(revision 121)
@@ -0,0 +1,20 @@
+.. documentation:
+
+ZOO Documentation
+=================
+
+The ZOO Project documentation is under construction. Here are listed the available 
+docs on differents components of the ZOO Project. Feel free to use it and 
+help us to write it !
+
+- ZOO Kernel documentation
+- ZOO Services documentation
+- ZOO API documentation 
+
+Workshop
+--------
+
+"Practical introduction to ZOO: The Open WPS Platform"
+
+- Wiki Material in english or in japanese.
+- ODT or PDF Material in english, japanese,  italian. 