Index: /trunk/docs/_templates/indexsidebar.html
===================================================================
--- /trunk/docs/_templates/indexsidebar.html	(revision 122)
+++ /trunk/docs/_templates/indexsidebar.html	(revision 123)
@@ -3,5 +3,5 @@
     <td>
       <a href="download.html">
-        <img src="_static/images/download.jpg" border="0px;" />
+        <img src="{{ pathto("_static/download.png", 1) }}" border="0px;" />
       </a>
     </td>
@@ -10,5 +10,5 @@
     <td>
       <a href="https://www.paypal.com/us/cgi-bin/webscr?cmd=_flow&SESSION=tSBDSUrN-pN-d3zZtpiuiW-QNEbjlnxta6hy1rmeICIKlJAxpPcpvK6npbi&dispatch=5885d80a13c0db1f8e263663d3faee8d5fa8ff279e37c3d9d4e38bdbee0ede69">
-        <img src="_static/images/donate.jpg" border="0px;" />
+        <img src="{{ pathto("_static/images/donate.jpg", 1) }}" border="0px;" />
       </a>
     </td>
@@ -17,5 +17,5 @@
     <td>
       <a href="http://twitter.com/ZOO_Project">
-        <img src="_static/images/twitter.jpg" border="0px;" />
+        <img src="{{ pathto("_static/images/twitter.jpg", 1) }}" border="0px;" />
       </a>
     </td>
Index: /trunk/docs/_templates/layout.html
===================================================================
--- /trunk/docs/_templates/layout.html	(revision 122)
+++ /trunk/docs/_templates/layout.html	(revision 123)
@@ -30,8 +30,8 @@
 
 {% block header %}
-    <img src="_static/images/header-logo.jpg">
+    <img src="{{ pathto("_static/images/header-logo.jpg", 1) }}">
 
 <ul class="topnav">
-  <li><a href="/site/">Home</a></li>
+  <li><a href="{{ pathto('index') }}">Home</a></li>
   <li><a href="#">ZOO Project</a>
        <ul class="subnav">
@@ -54,6 +54,6 @@
     </ul>
   </li>
-  <li><a href="download.html">Download</a></li>
-  <li><a href="/site/ZooDocumentation">Docs</a></li>
+  <li><a href="{{ pathto('dl/index') }}">Download</a></li>
+  <li><a href="{{ pathto('doc/index') }}">Docs</a></li>
   <li><a href="#">Demos</a>
     <ul class="subnav">
Index: /trunk/docs/conf.py
===================================================================
--- /trunk/docs/conf.py	(revision 122)
+++ /trunk/docs/conf.py	(revision 123)
@@ -38,5 +38,5 @@
 
 # The master toctree document.
-master_doc = 'documentation'
+master_doc = 'index'
 
 # General information about the project.
@@ -118,5 +118,5 @@
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-html_short_title = "Documentation"
+html_short_title = "ZOO Project"
 
 # The name of an image file (relative to this directory) to place at the top
Index: /trunk/docs/dl/index.txt
===================================================================
--- /trunk/docs/dl/index.txt	(revision 123)
+++ /trunk/docs/dl/index.txt	(revision 123)
@@ -0,0 +1,30 @@
+.. _download:
+
+ZOO Kernel Download
+===================
+
+ZOO Kernel is open source software available under the terms of the :ref:`MIT/X-11 style license <license>`. 
+Please see details of the ZOO Kernel license at the bottom of this page. Source code can 
+be compliled under Linux, Mac and Windows platforms. The latest ZOO Kernel version is 
+ZOO Kernel 1.0.
+
+Download ZOO Kernel source code
+-------------------------------
+
+`ZOO-Kernel-1.0.tar.bz2 <dl/ZOO-Kernel-1.0.tar.bz2>`__ / `ZOO-Kernel-1.0.zip <dl/ZOO-Kernel-1.0.zip>`__
+
+Or get the source code through SVN :
+
+::
+
+  svn checkout http://svn.zoo-project.org/svn/trunk zoo
+ 
+For registred developers, as the server waiting incoming SSH connexions on the 1046 port, 
+you'll have to edit your ~/.subversion/config file to add a tunnel. Let us name it as 
+zoossh, you can then use the following command :
+
+::
+
+  # sed "s:\[tunnels\]:\[tunnels\]\nzoosvn = /usr/bin/ssh -p 1046:g" -i ~/.subversion/config
+  # svn co svn+zoosvn://svn.zoo-project.org/var/svn/repos/trunk zoo-project
+ 
Index: unk/docs/documentation.txt
===================================================================
--- /trunk/docs/documentation.txt	(revision 122)
+++ 	(revision )
@@ -1,20 +1,0 @@
-.. documentation:
-
-ZOO Documentation
-=================
-
-The ZOO Project documentation is under construction. Here are listed the available 
-docs on differents components of the ZOO Project. Feel free to use it and 
-help us to write it !
-
-- ZOO Kernel documentation
-- ZOO Services documentation
-- ZOO API documentation 
-
-Workshop
---------
-
-"Practical introduction to ZOO: The Open WPS Platform"
-
-- Wiki Material in english or in japanese.
-- ODT or PDF Material in english, japanese,  italian. 
Index: unk/docs/download.txt
===================================================================
--- /trunk/docs/download.txt	(revision 122)
+++ 	(revision )
@@ -1,30 +1,0 @@
-.. _download:
-
-ZOO Kernel Download
-===================
-
-ZOO Kernel is open source software available under the terms of the :ref:`MIT/X-11 style license <license>`. 
-Please see details of the ZOO Kernel license at the bottom of this page. Source code can 
-be compliled under Linux, Mac and Windows platforms. The latest ZOO Kernel version is 
-ZOO Kernel 1.0.
-
-Download ZOO Kernel source code
--------------------------------
-
-`ZOO-Kernel-1.0.tar.bz2 <dl/ZOO-Kernel-1.0.tar.bz2>`__ / `ZOO-Kernel-1.0.zip <dl/ZOO-Kernel-1.0.zip>`__
-
-Or get the source code through SVN :
-
-::
-
-  svn checkout http://svn.zoo-project.org/svn/trunk zoo
- 
-For registred developers, as the server waiting incoming SSH connexions on the 1046 port, 
-you'll have to edit your ~/.subversion/config file to add a tunnel. Let us name it as 
-zoossh, you can then use the following command :
-
-::
-
-  # sed "s:\[tunnels\]:\[tunnels\]\nzoosvn = /usr/bin/ssh -p 1046:g" -i ~/.subversion/config
-  # svn co svn+zoosvn://svn.zoo-project.org/var/svn/repos/trunk zoo-project
- 