Index: /trunk/docs/_static/default.css
===================================================================
--- /trunk/docs/_static/default.css	(revision 123)
+++ /trunk/docs/_static/default.css	(revision 124)
@@ -73,5 +73,5 @@
 
 div.sphinxsidebar h3 {
-    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif';
     color: #663e05;
     font-size: 1.4em;
@@ -86,5 +86,5 @@
 
 div.sphinxsidebar h4 {
-    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif';
     color: #663e05;
     font-size: 1.3em;
@@ -146,5 +146,5 @@
 div.body h5,
 div.body h6 {
-    font-family: 'Verdana, Arial, Helvetica, sans-serif;
+    font-family: 'Verdana, Arial, Helvetica, sans-serif';
     background-color: #ffffff;
     font-weight: normal;
@@ -259,5 +259,5 @@
 }
 
-/*  Menu Bar ---------------------------------------- */
+/*  Custom Menu Bar ---------------------------------------- */
 
 ul.topnav {
@@ -335,2 +335,103 @@
  
 }
+
+/*  Custom Header ---------------------------------------- */
+
+#wrapper { 
+ margin: 0;
+ padding: 0;
+ width: 100%;
+}
+
+#myheader {
+ color: #333;
+ width: 100%;
+ height: 220px;
+ margin: 0;
+ background: #FFFFFF ;
+filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#FFFFFF', endColorstr='#fff196'); /* for IE */
+background:-webkit-gradient(linear, left top, left bottom, from(#FFFFFF), to(#fff196)); /* for webkit browsers */
+background:-moz-linear-gradient(top,  #FFFFFF, #fff196  ); /* for firefox 3.6+ */
+}
+
+.hleft{
+float:left;
+margin:0;
+width:380px;
+height:180px;
+background:url(images/zoo-title.png) no-repeat;}
+
+h1.title{width:290px;position:relative;top:115px;left:15px;font-size:1.4em;letter-spacing:2px;color:#727272;text-transform:uppercase;padding:5px;
+ background:#999999;
+ filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#e0e0e0', endColorstr='#bbbbbb'); /* for IE */
+background:-webkit-gradient(linear, left top, left bottom, from(#e0e0e0), to(#bbbbbb)); /* for webkit browsers */
+background:-moz-linear-gradient(top,  #e0e0e0,  #bbbbbb); /* for firefox 3.6+ */
+	-moz-border-radius: 5px;
+	-webkit-border-radius: 5px;
+	-webkit-border-radius: 5px;
+		border: 1px solid #d4d4d4;
+		text-align:center;
+		text-shadow: 1px 1px 1px #E0E0E0;
+}
+
+.orange{color:#ffaa17;display:block;padding:5px;}
+
+.hright{
+float:right;
+margin:0;
+width:533px;
+background:url(images/zoo-banner.png) no-repeat;
+height:180px;
+}
+
+/*  Custom Footer ---------------------------------------- */
+
+#footer { 
+	clear:both;
+ width:99.99%;
+ color: #333;
+ background: #ffcd0b;
+ filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffcd0b', endColorstr='#ee920c'); /* for IE */
+background:-webkit-gradient(linear, left top, left bottom, from(#ffcd0b), to(#ee920c)); /* for webkit browsers */
+background:-moz-linear-gradient(top,  #ffcd0b, #ee920c  ); /* for firefox 3.6+ */
+ margin: 0;
+ padding: 0;
+}
+
+#footer p{
+	padding: 0;
+	text-align: center;
+	margin: 0;
+}
+
+#footer a{
+	color: #563404;
+	font-weight: bold;
+	font-size: 14px;
+	text-decoration: none;
+}
+
+#footer .icon{
+	display: none;
+}
+
+#footer div{
+	text-align: center;
+}
+
+
+#footer .menuContainer{
+width: 750px; margin-left: auto; margin-right: auto;
+}
+
+#footer .menuItemList{
+	margin-top: 1em;
+	float: left;
+	padding-left: 1em;
+	padding-right: 1em;
+	border-left: 1px dashed #563404;;
+}
+
+#footer .menuItemList a{
+	font-weight: normal;
+}
Index: /trunk/docs/_templates/layout.html
===================================================================
--- /trunk/docs/_templates/layout.html	(revision 123)
+++ /trunk/docs/_templates/layout.html	(revision 124)
@@ -30,6 +30,14 @@
 
 {% block header %}
-    <img src="{{ pathto("_static/images/header-logo.jpg", 1) }}">
-
+<!-- Begin Header -->
+<div id="wrapper">
+  	<div id="myheader">
+    	<div class="hleft">
+    	  <h1 class="title">Open WPS Platform</h1>
+    	</div>
+    	<div class="hright">
+    	</div>
+  	</div>
+</div>
 <ul class="topnav">
   <li><a href="{{ pathto('index') }}">Home</a></li>
@@ -67,8 +75,84 @@
   </li>
   <li><a href="/trac">Trac</a></li>
+</ul>
+<!-- End Header -->
+    {{ super() }}
+{% endblock %}
 
-</ul>
+{% block footer %}
+<!-- Begin Footer -->
+<div id="footer">
+<div>
 
+<div>
+  <div class="menuContainer">
+    <div class="menuItemList">
+      <a href="{{ pathto('index') }}" shape="rect">Home</a>
+      <br/>
+    </div>
+    <div class="menuItemList">
+      <a href="#" shape="rect">ZOO Project</a>
 
+      <br/>
+      <a href="/site/ZooWebSite/ZooProject/About" shape="rect">About</a>
+      <br/>
+      <a href="/site/ZooWebSite/ZooProject/Tribe" shape="rect">ZOO Tribe</a>
+      <br/>
+      <a href="/site/ZooWebSite/ZooProject/Events" shape="rect">Events</a>
+      <br/>
+
+      <a href="/site/ZooWebSite/ZooProject/Photos" shape="rect">Photos</a>
+      <br/>
+      <a href="/site/ZooWebSite/ZooProject/Contact" shape="rect">Contacts</a>
+      <br/>
+    </div>
+    <div class="menuItemList">
+      <a href="#" shape="rect">Components</a>
+
+      <br/>
+      <a href="/site/ZooWebSite/ZooKernel" shape="rect">ZOO Kernel</a>
+      <br/>
+      <a href="/site/ZooWebSite/ZooServices" shape="rect">ZOO Services</a>
+      <br/>
+      <a href="/site/ZooWebsite/ZooApi" shape="rect">ZOO API</a>
+      <br/>
+
+    </div>
+    <div class="menuItemList">
+      <a href="{{ pathto('dl/index') }}" shape="rect">Download</a>
+      <br/>
+    </div>
+    <div class="menuItemList">
+      <a href="{{ pathto('doc/index') }}" shape="rect">Docs</a>
+      <br/>
+
+    </div>
+    <div class="menuItemList">
+      <a href="#" shape="rect">Demos</a>
+      <br/>
+      <a href="/site/ZooWebSite/Demo/SpatialTools" shape="rect">ZOO Spatial Tools</a>
+      <br/>
+      <a href="/site/ZooWebSite/Demo/WFS-T" shape="rect">ZOO Mapserver WFS-T</a>
+
+      <br/>
+      <a href="/site/ZooWebSite/Demo/GdalProfile" shape="rect">ZOO Elevation Profile</a>
+      <br/>
+      <a href="/site/ZooWebSite/Demo/FormTools" shape="rect">ZOO Form tools</a>
+      <br/>
+    </div>
+    <div class="menuItemList">
+      <a href="/trac" shape="rect">Trac</a>
+
+      <br/>
+    </div>
+  </div>
+  <br style="clear:both"/>
+</div>
+</div>
+<p>
+&copy; Copyright 2011 - <a class="ext-link" href="http://www.zoo-project.org" shape="rect"><span class="icon"> </span>ZOO Project</a> - All Rights Reserved. Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> {{sphinx_version}}.
+</p>
+</div>
+<!-- End Footer -->
     {{ super() }}
 {% endblock %}
Index: /trunk/docs/conf.py
===================================================================
--- /trunk/docs/conf.py	(revision 123)
+++ /trunk/docs/conf.py	(revision 124)
@@ -105,6 +105,4 @@
     "visitedlinkcolor": "#fc9326",    
     "sidebarbgcolor": "white",
-    "footerbgcolor": "#ffffff",
-    "footertextcolor": "#646464",    
     "relbarbgcolor": "#5e3905"    
 }
@@ -164,8 +162,8 @@
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+html_show_sphinx = False
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+html_show_copyright = False
 
 # If true, an OpenSearch description file will be output, and all pages will